// StatusPrettyPrint.h

/*********************
Yusheng Yang
Real-Time Innovations
August 4th, 2008
**********************/

/****************************************************************************************
StatusPrettyPrint is a static class for printing reader/writer statistics to a .csv file.
*****************************************************************************************/

using namespace std;

#define GUID_LENGTH 16

class Status_PrettyPrint_API
{
	public:

		/* methods */				
		static DDS_ReturnCode_t print_reader_status_to_csv (DDSDataReader *reader);
		static DDS_ReturnCode_t print_reader_status_to_csv (DDSDataReader *reader, const char csvFile[]);
		static DDS_ReturnCode_t print_writer_status_to_csv (DDSDataWriter *writer);
		static DDS_ReturnCode_t print_writer_status_to_csv (DDSDataWriter *writer, const char csvFile[]);
		static DDS_ReturnCode_t init_reader_status_csv(DDSDataReader *reader);
		static DDS_ReturnCode_t init_reader_status_csv(DDSDataReader *reader, const char csvFile[]);
		static DDS_ReturnCode_t init_writer_status_csv(DDSDataWriter *writer);
		static DDS_ReturnCode_t init_writer_status_csv(DDSDataWriter *writer, const char csvFile[]);

	private:

		/* methods */
		static DDS_ReturnCode_t print_timestamp(DDSDomainParticipant *participant, ofstream &outfile);
		static DDS_ReturnCode_t print_reader_status_title(DDSDataReader *reader, ofstream &outfile);
		static void print_reader_column_headers(DDSDataReader *reader, ofstream &outfile);
		static DDS_ReturnCode_t print_reader_cache_status(DDSDataReader *reader, ofstream &outfile);
		static DDS_ReturnCode_t print_reader_protocol_status(DDSDataReader *reader, ofstream &outfile);
		static DDS_ReturnCode_t print_writer_status_title(DDSDataWriter *writer, ofstream &outfile);
		static void print_writer_column_headers(DDSDataWriter *writer, ofstream &outfile);
		static DDS_ReturnCode_t print_writer_cache_status(DDSDataWriter *writer, ofstream &outfile);
		static DDS_ReturnCode_t print_writer_protocol_status(DDSDataWriter *writer, ofstream &outfile);
		static DDS_ReturnCode_t get_reader_guid_string(DDSDataReader *reader, string &reader_guid_string);
		static DDS_ReturnCode_t get_writer_guid_string(DDSDataWriter *writer, string &writer_guid_string);
		static string DDSOctet2hexStr(DDS_Octet oct);
};
